-- Register Control
-- Designed by T.Iwata at DIGITALFILTER.COM 2006/05/15

library IEEE;
  use IEEE.std_logic_1164.all;
  use IEEE.std_logic_arith.all;

entity REG_CTRL is
   Port (
          REGCLK : In std_logic; 
          RST_N : In std_logic; 
          REGDATA : In std_logic;
          REGLATCH : In std_logic; 
          GENPERIOD : Out std_logic_vector(7 downto 0);
          GENTYPE : Out std_logic;
          TRIGPOS : Out std_logic_vector(1 downto 0);
          TRIGPAT : Out std_logic_vector(7 downto 0);
          DIVIDE : Out std_logic_vector(1 downto 0) ); 
end REG_CTRL;

architecture STRUCTURE of REG_CTRL is

  signal pdata : std_logic_vector( 23 downto 0 );
  signal reg : std_logic_vector( 23 downto 0 );

begin -- architecture REG_CTRL

-------------------------------------------------------------------
gen_pdata : process( RST_N, REGCLK ) 
begin
  if(RST_N = '0') then
    pdata <= (others => '0');
  elsif( REGCLK'event and REGCLK = '1' ) then
    pdata <= pdata(22 downto 0) & REGDATA;
  end if;
end process;

-------------------------------------------------------------------
gen_reg : process( RST_N, REGLATCH ) 
begin
  if(RST_N = '0') then
    reg <= (others => '0');
  elsif( REGLATCH'event and REGLATCH = '1' ) then
    reg <= pdata;
  end if;
end process;

-------------------------------------------------------------------
   GENPERIOD <= reg(7 downto 0);
   GENTYPE <= reg(8);
   TRIGPAT <= reg(16 downto 9);
   TRIGPOS <= reg(18 downto 17);
   DIVIDE <= reg(20 downto 19);
   
end;
